diff --git a/src/main/java/net/minecraft/core/block/BlockChest.java b/src/main/java/net/minecraft/core/block/ChestBlock.java
similarity index 85%
rename from src/main/java/net/minecraft/core/block/BlockChest.java
rename to src/main/java/net/minecraft/core/block/ChestBlock.java
index 75f45cbc8..cf33e6946 100644
--- a/src/main/java/net/minecraft/core/block/BlockChest.java
+++ b/src/main/java/net/minecraft/core/block/ChestBlock.java
@@ -1,30 +1,30 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.entity.TileEntityChest;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.ChestBlockEntity;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.EntityItem;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.inventory.IInventory;
-import net.minecraft.core.player.inventory.InventoryLargeChest;
+import net.minecraft.core.player.inventory.container.Container;
+import net.minecraft.core.player.inventory.container.CompoundContainer;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public class BlockChest extends BlockTileEntity {
+public class ChestBlock extends EntityBlock {
 	
-	public BlockChest(String key, int id, Material material) {
-		super(key, id, material);
+	public ChestBlock(String key, String namespaceId, int id, Material material) {
+		super(key, namespaceId, id, material);
 	}
 	
 	@Override
-	public void onBlockPlaced(World world, int x, int y, int z, Side placeSide, EntityLiving entity, double sideHeight) {
-		Direction direction = entity.getHorizontalPlacementDirection(placeSide).getOpposite();
+	public void onBlockPlacedByMob(World world, int x, int y, int z, Side placeSide, Mob mob, double sideHeight) {
+		Direction direction = mob.getHorizontalPlacementDirection(placeSide).getOpposite();
 		Type type = Type.SINGLE;
 		
-		if(entity.isSneaking() && placeSide.isHorizontal() && (entity.rotationLockHorizontal == null || entity.rotationLockHorizontal == Direction.NONE)) {
+		if(mob.isSneaking() && placeSide.isHorizontal() && (mob.rotationLockHorizontal == null || mob.rotationLockHorizontal == Direction.NONE)) {
 			int placedOnX = x;
 			int placedOnZ = z;
 			if(placeSide == Side.NORTH) placedOnZ++;
@@ -83,7 +83,7 @@ public class BlockChest extends BlockTileEntity {
 					}
 				}
 			}
-		}else if(!entity.isSneaking()) {
+		}else if(!mob.isSneaking()) {
 			if(direction == Direction.NORTH) {
 				if(isSingleChestWithDirection(world, x - 1, y, z, direction) && !isSingleChestWithDirection(world, x + 1, y, z, direction)) {
 					type = Type.LEFT;
@@ -190,25 +190,25 @@ public class BlockChest extends BlockTileEntity {
 	}
 	
 	public static void dropChestContent(World world, int x, int y, int z) {
-		TileEntityChest tileEntityChest = (TileEntityChest) world.getBlockTileEntity(x, y, z);
+		ChestBlockEntity tileEntityChest = (ChestBlockEntity) world.getBlockEntity(x, y, z);
 		if(tileEntityChest == null) {
 			System.out.println("Can't drop chest items because tile entity is null at x: "+x+" y:"+y+" z: "+z);
 			return;
 		}
 		
-		for(int i=0; i < tileEntityChest.getSizeInventory(); i++) {
-			ItemStack itemStack = tileEntityChest.getStackInSlot(i);
+		for(int i = 0; i < tileEntityChest.getContainerSize(); i++) {
+			ItemStack itemStack = tileEntityChest.getItem(i);
 			if(itemStack == null) continue;
-			EntityItem item = world.dropItem(x, y, z, itemStack);
+			ItemEntity item = world.dropItem(x, y, z, itemStack);
 			item.xd *= 0.5;
 			item.yd *= 0.5;
 			item.zd *= 0.5;
-			item.delayBeforeCanPickup = 0;
+			item.pickupDelay = 0;
 		}
 	}
 	
 	public static boolean isChest(World world, int x, int y, int z) {
-		return Block.blocksList[world.getBlockId(x, y, z)] instanceof BlockChest;
+		return Block.blocksList[world.getBlockId(x, y, z)] instanceof ChestBlock;
 	}
 	
 	public static boolean isSingleChest(World world, int x, int y, int z) {
@@ -221,8 +221,8 @@ public class BlockChest extends BlockTileEntity {
 	}
 	
 	@Override
-	protected TileEntity getNewBlockEntity() {
-		return new TileEntityChest();
+	protected BlockEntity getNewBlockEntity() {
+		return new ChestBlockEntity();
 	}
 	
 	public void setDirection(World world, int x, int y, int z, Direction direction) {
@@ -245,7 +245,7 @@ public class BlockChest extends BlockTileEntity {
 	}
 	
 	@Override
-	public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced) {
+	public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced) {
 		if(world.isClientSide) return true;
 		
 		checkIfOtherHalfExists(world, x, y, z);
@@ -254,15 +254,15 @@ public class BlockChest extends BlockTileEntity {
 		return true;
 	}
 	
-	public static IInventory getInventory(World world, int x, int y, int z) {
-		IInventory inventory = (IInventory) world.getBlockTileEntity(x, y, z);
+	public static Container getInventory(World world, int x, int y, int z) {
+		Container inventory = (Container) world.getBlockEntity(x, y, z);
 		
 		int meta = world.getBlockMetadata(x, y, z);
 		meta = world.getBlockMetadata(x, y, z);
 		Type type = getTypeFromMeta(meta);
 		
 		if(type != Type.SINGLE) {
-			IInventory inv2 = null;
+			Container inv2 = null;
 			
 			Direction direction = getDirectionFromMeta(meta); 
 			
@@ -291,16 +291,16 @@ public class BlockChest extends BlockTileEntity {
 				if(getDirectionFromMeta(otherMeta) == direction) {
 					Type otherType = getTypeFromMeta(otherMeta);
 					if(type == Type.LEFT && otherType == Type.RIGHT) {
-						inv2 = (IInventory) world.getBlockTileEntity(otherChestX, y, otherChestZ);
+						inv2 = (Container) world.getBlockEntity(otherChestX, y, otherChestZ);
 					}
 					if(type == Type.RIGHT && otherType == Type.LEFT) {
 						inv2 = inventory;
-						inventory = (IInventory) world.getBlockTileEntity(otherChestX, y, otherChestZ);
+						inventory = (Container) world.getBlockEntity(otherChestX, y, otherChestZ);
 					}
 				}
 			}
 			if(inv2 != null) {
-				inventory = new InventoryLargeChest("Large Chest", inventory, inv2);
+				inventory = new CompoundContainer("Large Chest", inventory, inv2);
 			}
 		}
 		
diff --git a/src/main/java/net/minecraft/core/block/BlockChestPainted.java b/src/main/java/net/minecraft/core/block/ChestBlockPainted.java
similarity index 66%
rename from src/main/java/net/minecraft/core/block/BlockChestPainted.java
rename to src/main/java/net/minecraft/core/block/ChestBlockPainted.java
index 06095e7bb..04c02daa6 100644
--- a/src/main/java/net/minecraft/core/block/BlockChestPainted.java
+++ b/src/main/java/net/minecraft/core/block/ChestBlockPainted.java
@@ -1,19 +1,19 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 
-public class BlockChestPainted extends BlockChest {
+public class ChestBlockPainted extends ChestBlock {
 
-	protected BlockChestPainted(String key, int id, Material material) {
-		super(key, id, material);
+	protected ChestBlockPainted(String key, String namespaceId, int id, Material material) {
+		super(key, namespaceId, id, material);
 	}
 
 	@Override
-	public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+	public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
 	{
 		return new ItemStack[] { new ItemStack(this, 1, meta & colorBits) };
 	}
diff --git a/src/main/java/net/minecraft/core/block/BlockClay.java b/src/main/java/net/minecraft/core/block/ClayBlock.java
similarity index 58%
rename from src/main/java/net/minecraft/core/block/BlockClay.java
rename to src/main/java/net/minecraft/core/block/ClayBlock.java
index 6a4723418..75325cf9d 100644
--- a/src/main/java/net/minecraft/core/block/BlockClay.java
+++ b/src/main/java/net/minecraft/core/block/ClayBlock.java
@@ -1,25 +1,27 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 
+import java.util.HashMap;
+import java.util.Map;
+
 // Referenced classes of package net.minecraft.src:
 //            Block, Material, Item
 
-public class BlockClay extends Block
+public class ClayBlock extends Block
 {
-
-    public BlockClay(String key, int id)
+    public ClayBlock(String key, String namespaceId, int id)
     {
-        super(key, id, Material.clay);
+        super(key, namespaceId, id, Material.clay);
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         switch (dropCause)
         {
@@ -27,7 +29,7 @@ public class BlockClay extends Block
             case PICK_BLOCK:
                 return new ItemStack[] { new ItemStack(this) };
             default:
-                return new ItemStack[] { new ItemStack(Item.clay, 4) };
+                return new ItemStack[] { new ItemStack(Items.CLAY, 4) };
         }
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockOreDiamond.java b/src/main/java/net/minecraft/core/block/CoalOreBlock.java
similarity index 54%
rename from src/main/java/net/minecraft/core/block/BlockOreDiamond.java
rename to src/main/java/net/minecraft/core/block/CoalOreBlock.java
index 19d271f46..e0d3bf7d3 100644
--- a/src/main/java/net/minecraft/core/block/BlockOreDiamond.java
+++ b/src/main/java/net/minecraft/core/block/CoalOreBlock.java
@@ -1,25 +1,29 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 
+import java.util.HashMap;
+import java.util.Map;
+
 // Referenced classes of package net.minecraft.src:
 //            Block, Material, Item
 
-public class BlockOreDiamond extends Block
+public class CoalOreBlock extends Block
 {
+    public static Map<Integer, Integer> variantMap = new HashMap<>();
 
-    public BlockOreDiamond(String key, int id)
-    {
-        super(key, id, Material.stone);
+    public CoalOreBlock(String key, String namespaceId, int id, int parentId, Material material){
+        super(key, namespaceId, id, material);
+        variantMap.put(parentId, id);
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         switch (dropCause)
         {
@@ -28,10 +32,9 @@ public class BlockOreDiamond extends Block
                 return new ItemStack[] { new ItemStack(this) };
             case EXPLOSION:
             case PROPER_TOOL:
-                return new ItemStack[] { new ItemStack(Item.diamond) };
+                return new ItemStack[] { new ItemStack(Items.COAL) };
             default:
                 return null;
         }
     }
-
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockCobweb.java b/src/main/java/net/minecraft/core/block/CobwebBlock.java
similarity index 75%
rename from src/main/java/net/minecraft/core/block/BlockCobweb.java
rename to src/main/java/net/minecraft/core/block/CobwebBlock.java
index 745993810..0a991ac16 100644
--- a/src/main/java/net/minecraft/core/block/BlockCobweb.java
+++ b/src/main/java/net/minecraft/core/block/CobwebBlock.java
@@ -1,9 +1,9 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
@@ -14,12 +14,12 @@ import net.minecraft.core.world.WorldSource;
 //            Block, Material, Entity, Item, 
 //            World, AxisAlignedBB
 
-public class BlockCobweb extends Block
+public class CobwebBlock extends Block
 {
 
-    public BlockCobweb(String key, int id, Material mat)
+    public CobwebBlock(String key, String namespaceId, int id, Material mat)
     {
-        super(key, id, mat);
+        super(key, namespaceId, id, mat);
     }
 
     @Override
@@ -30,7 +30,7 @@ public class BlockCobweb extends Block
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         switch (dropCause)
         {
@@ -39,7 +39,7 @@ public class BlockCobweb extends Block
                 return new ItemStack[] { new ItemStack(this) };
             case EXPLOSION:
             case PROPER_TOOL:
-                return new ItemStack[] { new ItemStack(Item.string) };
+                return new ItemStack[] { new ItemStack(Items.STRING) };
             default:
                 return null;
         }
@@ -58,7 +58,7 @@ public class BlockCobweb extends Block
     }
 
     @Override
-	public boolean renderAsNormalBlock()
+	public boolean isCubeShaped()
     {
         return false;
     }
diff --git a/src/main/java/net/minecraft/core/block/BlockCropsPumpkin.java b/src/main/java/net/minecraft/core/block/CropsPumpkinBlock.java
similarity index 78%
rename from src/main/java/net/minecraft/core/block/BlockCropsPumpkin.java
rename to src/main/java/net/minecraft/core/block/CropsPumpkinBlock.java
index f8122bf0b..1102c2373 100644
--- a/src/main/java/net/minecraft/core/block/BlockCropsPumpkin.java
+++ b/src/main/java/net/minecraft/core/block/CropsPumpkinBlock.java
@@ -1,10 +1,10 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.IBonemealable;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
@@ -13,10 +13,10 @@ import net.minecraft.core.world.WorldSource;
 
 import java.util.Random;
 
-public class BlockCropsPumpkin
-    extends BlockFlower implements IBonemealable {
-    public BlockCropsPumpkin(String key, int id) {
-        super(key, id);
+public class CropsPumpkinBlock
+    extends FlowerBlock implements IBonemealable {
+    public CropsPumpkinBlock(String key, String namespaceId, int id) {
+        super(key, namespaceId, id);
     }
 
     @Override
@@ -41,7 +41,7 @@ public class BlockCropsPumpkin
 
     @Override
     protected boolean canThisPlantGrowOnThisBlockID(int i) {
-        return i == Block.farmlandDirt.id;
+        return i == Blocks.FARMLAND_DIRT.id;
     }
 
     @Override
@@ -54,7 +54,7 @@ public class BlockCropsPumpkin
                 if (rand.nextInt((int) (100F / f)) == 0) {
                     meta++;
                     if (meta == 5) {
-                        world.setBlockAndMetadataWithNotify(x, y, z, Block.pumpkin.id, 0);
+                        world.setBlockAndMetadataWithNotify(x, y, z, Blocks.PUMPKIN.id, 0);
                     } else {
                         world.setBlockMetadataWithNotify(x, y, z, meta);
                     }
@@ -64,7 +64,7 @@ public class BlockCropsPumpkin
     }
 
     public void fertilize(World world, int x, int y, int z) {
-        world.setBlockWithNotify(x, y, z, Block.pumpkin.id);
+        world.setBlockWithNotify(x, y, z, Blocks.PUMPKIN.id);
     }
 
     private float getGrowthRate(World world, int x, int y, int z) {
@@ -84,7 +84,7 @@ public class BlockCropsPumpkin
             for(int dz = z - 1; dz <= z + 1; dz++) {
                 int id = world.getBlockId(dx, y - 1, dz);
                 float growthRateMod = 0.0F;
-                if(id == Block.farmlandDirt.id) {
+                if(id == Blocks.FARMLAND_DIRT.id) {
                     growthRateMod = 1.0F;
                     if(world.getBlockMetadata(dx, y - 1, dz) > 0) {
                         growthRateMod = 3F;
@@ -98,7 +98,7 @@ public class BlockCropsPumpkin
 
         }
 
-        boolean isFertilized = BlockFarmland.isFertilized(world.getBlockMetadata(x, y - 1, z));
+        boolean isFertilized = FarmlandBlock.isFertilized(world.getBlockMetadata(x, y - 1, z));
         if (!isFertilized) {
             if (world.getSeasonManager().getCurrentSeason() != null)
             {
@@ -111,8 +111,8 @@ public class BlockCropsPumpkin
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity) {
-        return new ItemStack[] { new ItemStack(Item.seedsPumpkin, 1)};
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity) {
+        return new ItemStack[] { new ItemStack(Items.SEEDS_PUMPKIN, 1)};
     }
 
     public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z) {
@@ -121,16 +121,16 @@ public class BlockCropsPumpkin
         if (meta == 0) {
             return null;
         }
-        return AABB.getBoundingBoxFromPool((double)x + minX, (double)y + minY, (double)z + minZ, (double)x + maxX, (double)y + maxY, (double)z + maxZ);
+        return AABB.getTemporaryBB((double)x + minX, (double)y + minY, (double)z + minZ, (double)x + maxX, (double)y + maxY, (double)z + maxZ);
     }
 
     @Override
-    public boolean onBonemealUsed(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+    public boolean onBonemealUsed(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         if (world.getBlockMetadata(blockX, blockY, blockZ) < 5)
         {
             if (!world.isClientSide)
             {
-                ((BlockCropsPumpkin)Block.cropsPumpkin).fertilize(world, blockX, blockY, blockZ);
+                ((CropsPumpkinBlock)Blocks.CROPS_PUMPKIN).fertilize(world, blockX, blockY, blockZ);
                 if (entityplayer.getGamemode().consumeBlocks())
                 {
                     itemstack.stackSize--;
diff --git a/src/main/java/net/minecraft/core/block/BlockCropsWheat.java b/src/main/java/net/minecraft/core/block/CropsWheatBlock.java
similarity index 75%
rename from src/main/java/net/minecraft/core/block/BlockCropsWheat.java
rename to src/main/java/net/minecraft/core/block/CropsWheatBlock.java
index decfac4ab..6fa8943f3 100644
--- a/src/main/java/net/minecraft/core/block/BlockCropsWheat.java
+++ b/src/main/java/net/minecraft/core/block/CropsWheatBlock.java
@@ -2,24 +2,25 @@ package net.minecraft.core.block;
 
 import java.util.Random;
 
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.IBonemealable;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
 // Referenced classes of package net.minecraft.src:
-//            BlockFlower, Block, World, EntityItem, 
+//            FlowerBlock, Block, World, ItemEntity,
 //            ItemStack, Item
 
-public class BlockCropsWheat extends BlockFlower implements IBonemealable
+public class CropsWheatBlock extends FlowerBlock implements IBonemealable
 {
-	public BlockCropsWheat(String key, int id)
+	public CropsWheatBlock(String key, String namespaceId, int id)
     {
-        super(key, id);
+        super(key, namespaceId, id);
         setTicking(true);
         float f = 0.5F;
         setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, 0.25F, 0.5F + f);
@@ -28,7 +29,7 @@ public class BlockCropsWheat extends BlockFlower implements IBonemealable
 	@Override
 	public boolean canThisPlantGrowOnThisBlockID(int i)
     {
-        return i == Block.farmlandDirt.id;
+        return i == Blocks.FARMLAND_DIRT.id;
     }
 
     @Override
@@ -75,7 +76,7 @@ public class BlockCropsWheat extends BlockFlower implements IBonemealable
             {
                 int id = world.getBlockId(dx, y - 1, dz);
                 float growthRateMod = 0.0F;
-                if(id == Block.farmlandDirt.id)
+                if(id == Blocks.FARMLAND_DIRT.id)
                 {
                     growthRateMod = 1.0F;
                     if(world.getBlockMetadata(dx, y - 1, dz) > 0)
@@ -96,7 +97,7 @@ public class BlockCropsWheat extends BlockFlower implements IBonemealable
             growthRate /= 2.0F;
         }
 
-        boolean isFertilized = BlockFarmland.isFertilized(world.getBlockMetadata(x, y - 1, z));
+        boolean isFertilized = FarmlandBlock.isFertilized(world.getBlockMetadata(x, y - 1, z));
         if (!isFertilized) {
             if (world.getSeasonManager().getCurrentSeason() != null)
             {
@@ -109,36 +110,36 @@ public class BlockCropsWheat extends BlockFlower implements IBonemealable
     }
 
     @Override
-    public void onBlockDestroyedByPlayer(World world, int x, int y, int z, Side side, int meta, EntityPlayer player, Item item) {
-        boolean isFertilized = BlockFarmland.isFertilized(world.getBlockMetadata(x, y - 1, z));
+    public void onBlockDestroyedByPlayer(World world, int x, int y, int z, Side side, int meta, Player player, Item item) {
+        boolean isFertilized = FarmlandBlock.isFertilized(world.getBlockMetadata(x, y - 1, z));
         if (isFertilized && !world.isClientSide) {
             boolean shouldDefertilize = world.rand.nextInt(3) == 2;
             if (shouldDefertilize) {
-                world.setBlockMetadata(x, y - 1, z, BlockFarmland.setFertilized(world.getBlockMetadata(x, y - 1, z), false));
+                world.setBlockMetadata(x, y - 1, z, FarmlandBlock.setFertilized(world.getBlockMetadata(x, y - 1, z), false));
             }
         }
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         if (meta != 7)
         {
-            return new ItemStack[] { new ItemStack(Item.seedsWheat) };
+            return new ItemStack[] { new ItemStack(Items.SEEDS_WHEAT) };
         }
         else
         {
-            return new ItemStack[] { new ItemStack(Item.seedsWheat, world.rand.nextInt(3) + 1), new ItemStack(Item.wheat) };
+            return new ItemStack[] { new ItemStack(Items.SEEDS_WHEAT, world.rand.nextInt(3) + 1), new ItemStack(Items.WHEAT) };
         }
     }
 
     @Override
-    public boolean onBonemealUsed(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+    public boolean onBonemealUsed(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         if(world.getBlockMetadata(blockX, blockY, blockZ) < 7)
         {
             if(!world.isClientSide)
             {
-                ((BlockCropsWheat)Block.cropsWheat).fertilize(world, blockX, blockY, blockZ);
+                ((CropsWheatBlock)Blocks.CROPS_WHEAT).fertilize(world, blockX, blockY, blockZ);
                 if (entityplayer.getGamemode().consumeBlocks())
                 {
                     itemstack.stackSize--;
diff --git a/src/main/java/net/minecraft/core/block/BlockDeadBush.java b/src/main/java/net/minecraft/core/block/DeadBushBlock.java
similarity index 61%
rename from src/main/java/net/minecraft/core/block/BlockDeadBush.java
rename to src/main/java/net/minecraft/core/block/DeadBushBlock.java
index 38bfd8924..d8d4431d9 100644
--- a/src/main/java/net/minecraft/core/block/BlockDeadBush.java
+++ b/src/main/java/net/minecraft/core/block/DeadBushBlock.java
@@ -1,20 +1,20 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 
 // Referenced classes of package net.minecraft.src:
-//            BlockFlower, Block
+//            FlowerBlock, Block
 
-public class BlockDeadBush extends BlockFlower
+public class DeadBushBlock extends FlowerBlock
 {
 
-	public BlockDeadBush(String key, int id)
+	public DeadBushBlock(String key, String namespaceId, int id)
     {
-        super(key, id);
+        super(key, namespaceId, id);
         float f = 0.4F;
         setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, 0.8F, 0.5F + f);
     }
@@ -22,11 +22,11 @@ public class BlockDeadBush extends BlockFlower
     @Override
 	public boolean canThisPlantGrowOnThisBlockID(int i)
     {
-        return i == Block.sand.id || i == Block.dirtScorched.id;
+        return i == Blocks.SAND.id || i == Blocks.DIRT_SCORCHED.id;
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         int quantity = world.rand.nextInt(3);
 
@@ -37,7 +37,7 @@ public class BlockDeadBush extends BlockFlower
                 return new ItemStack[] { new ItemStack(this) };
             default:
                 if (quantity == 0) return null;
-                return new ItemStack[] { new ItemStack(Item.stick, quantity) };
+                return new ItemStack[] { new ItemStack(Items.STICK, quantity) };
         }
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/DetectorRailBlock.java b/src/main/java/net/minecraft/core/block/DetectorRailBlock.java
new file mode 100644
index 000000000..974d0324e
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/DetectorRailBlock.java
@@ -0,0 +1,93 @@
+package net.minecraft.core.block;
+
+import java.util.List;
+import java.util.Random;
+
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.vehicle.MinecartEntity;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.World;
+public class DetectorRailBlock extends RailBlock {
+    public DetectorRailBlock(String key, String namespaceId, int id)
+    {
+        super(key, namespaceId, id, true);
+        setTicking(true);
+    }
+
+    @Override
+    public int tickDelay()
+    {
+        return 20;
+    }
+
+    @Override
+    public boolean isSignalSource()
+    {
+        return true;
+    }
+
+    @Override
+    public void onEntityCollidedWithBlock(World world, int x, int y, int z, Entity entity) {
+        if(world.isClientSide) {
+            return;
+        }
+        int meta = world.getBlockMetadata(x, y, z);
+        if ((meta & 8) == 0) { // If unpowered
+            checkForMinecart(world, x, y, z, meta);
+        }
+    }
+
+    @Override
+	public void updateTick(World world, int x, int y, int z, Random rand) {
+        if(world.isClientSide) {
+            return;
+        }
+        int meta = world.getBlockMetadata(x, y, z);
+        if ((meta & 8) != 0) { // If powered
+            checkForMinecart(world, x, y, z, meta);
+        }
+    }
+
+    @Override
+    public boolean getSignal(WorldSource worldSource, int x, int y, int z, Side side) {
+        return (worldSource.getBlockMetadata(x, y, z) & 8) != 0;
+    }
+
+    @Override
+    public boolean getDirectSignal(World world, int x, int y, int z, Side side) {
+        if((world.getBlockMetadata(x, y, z) & 8) == 0) {
+            return false;
+        } else {
+            return side == Side.TOP;
+        }
+    }
+    private void checkForMinecart(World world, int x, int y, int z, int meta) {
+        boolean isPowered = (meta & 8) != 0;
+        boolean minecartPresent = false;
+        float offset = 0.125f;
+        List<Entity> list = world.getEntitiesWithinAABB(MinecartEntity.class, AABB.getTemporaryBB(x + offset, y + offset, z + offset, x + 1 - offset, y + 1 - offset, z + 1 - offset));
+        if(!list.isEmpty()) {
+            minecartPresent = true;
+        }
+        if(minecartPresent && !isPowered) {
+            // Set rail to powered
+            world.setBlockMetadataWithNotify(x, y, z, meta | 8);
+            world.notifyBlocksOfNeighborChange(x, y, z, id);
+            world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+            world.markBlocksDirty(x, y, z, x, y, z);
+        }
+        if(!minecartPresent && isPowered) {
+            // Set rail to unpowered
+            world.setBlockMetadataWithNotify(x, y, z, meta & 7);
+            world.notifyBlocksOfNeighborChange(x, y, z, id);
+            world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+            world.markBlocksDirty(x, y, z, x, y, z);
+        }
+        if(minecartPresent) {
+            // Schedule update if minecart in rail
+            world.scheduleBlockUpdate(x, y, z, id, tickDelay());
+        }
+    }
+}
